<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" >
      <el-form-item label="计划名称：" prop="name">
        <el-input
          v-model.trim="queryParams.name"
          placeholder="请输入计划名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item class="right">
        <el-button plain size="mini" @click="resetQuery">重置</el-button>
        <el-button type="primary" size="mini" @click="handleQuery">搜索</el-button>
      </el-form-item>
      <br>
      <el-button
        type="primary"
        size="mini"
        @click="handleAdd"
      >新增</el-button>
    </el-form>
    <el-table v-loading="loading" :data="adminList" style="margin-top:20px;" border>
      <el-table-column label="计划名称" align="center" prop="name"  show-overflow-tooltip />
      <el-table-column label="周期" align="center" prop="cycle"  show-overflow-tooltip >
        <template slot-scope="scope">
          <span>{{scope.row.cycle == 1 ? "日" : scope.row.cycle == 2 ? "周" : "月"}}</span>
        </template>
      </el-table-column>
      <el-table-column label="计划开始时间" align="center" prop="startTime"  show-overflow-tooltip />
      <el-table-column label="计划结束时间" align="center" prop="endTime"  show-overflow-tooltip />
      <el-table-column label="执行开始时间" align="center" prop="startInspectTime"  show-overflow-tooltip />
      <el-table-column label="执行结束时间" align="center" prop="endInspectTime"  show-overflow-tooltip />
      <el-table-column label="执行班组" align="center" prop="teamName"  show-overflow-tooltip />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" >
        <template slot-scope="scope">
          <el-button
            size="mini"
            class="lans"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            size="mini"
            class="hongs"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 修改、新增对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="640px" append-to-body :before-close="cancel" :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="120px" >
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="计划名称" prop="name">
              <el-input v-model="form.name" placeholder="请填写计划名称" @input="onInput()" maxlength="15" show-word-limit  />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="执行班组" prop="teamId">
              <el-select
                v-model="form.teamId"
                placeholder="请选择执行班组"
                size="small"
                style="width: 160px"
              >
                <el-option
                  v-for="dict in teamList"
                  :key="dict.id"
                  :label="dict.name"
                  :value="dict.id"
                  width="30%"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="计划开始时间" prop="startTime">
              <el-date-picker
                v-model="form.startTime"
                type="date"
                style="width:160px"
                placeholder="选择日期">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="计划结束时间" prop="endTime">
              <el-date-picker
                v-model="form.endTime"
                type="date"
                style="width:160px;"
                placeholder="选择日期">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="执行开始时间" prop="startInspectTime">
              <el-select
                v-model="form.startInspectTime"
                placeholder="请选择开始时间"
                size="small"
                style="width: 160px"
              >
                <el-option
                  v-for="dict in implementTimeStart"
                  :key="dict.value"
                  :label="dict.value"
                  :value="dict.value"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="执行结束时间" prop="endInspectTime">
              <el-select
                v-model="form.endInspectTime"
                placeholder="请选择结束时间"
                size="small"
                style="width: 160px"
              >
                <el-option
                  v-for="dict in implementTimeEnd"
                  :key="dict.value"
                  :label="dict.value"
                  :value="dict.value"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="周期" prop="cycle">
              <el-select
                v-model="form.cycle"
                placeholder="请选择周期"
                size="small"
                style="width: 160px;"

              >
                <el-option
                  v-for="dict in cycleList"
                  :key="dict.dictValue"
                  :label="dict.dictLabel"
                  :value="dict.dictValue"
                />
              </el-select>
            </el-form-item>
          </el-col>

          <el-col style="font-size:16px;font-weight:700;margin:10px 0 20px;">巡更路线</el-col>
          <el-table v-loading="loading2" :data="adminList2" height="150"   @select="dialogCheck" ref="dataTable" @selection-change="handleSelectionChange" style="margin-bottom:50px">
            <el-table-column type="selection" />
            <el-table-column label="线路名称" align="center" prop="name"  show-overflow-tooltip />
            <el-table-column label="创建时间" align="center" prop="createTime"  show-overflow-tooltip />
          </el-table>
          <el-pagination
            style="bottom:0px"
            background
            @current-change="handleCurrentChange2"
            :page-sizes="[10, 15, 20, 30]"
            @size-change="handleSizeChange2"
            :current-page="queryParams2.pageNo"
            :page-size="queryParams2.pageSize"
            layout="sizes,prev, pager, next"
            :total="totalCount2"
          >
          </el-pagination>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel" plain>取 消</el-button>
      </div>
    </el-dialog>
    <el-pagination
      background
      @current-change="handleCurrentChange1"
      :page-sizes="[10, 15, 20, 30]"
      @size-change="handleSizeChange1"
      :current-page="queryParams.pageNo"
      :page-size="queryParams.pageSize"
      layout="sizes,prev, pager, next"
      :total="totalCount1"
    >
    </el-pagination>
    <a href="" download="" id="xz" style="position: absolute;z-index: -1;opacity: 0;"></a>
  </div>
</template>
<script>
import { timestampToTime, getTimeFormat,YearMonthDate } from "@/assets/js/dataFormate.js";
import { getPlanPath } from "@/api/MochaITOM/route";
import { addMaintianPlan, delMaintianPlan, updateMaintianPlan, getMaintianPlan, exportMaintianPlan } from "@/api/MochaITOM/plan";
import { getDevopsTeam } from "@/api/MochaITOM/crew";
export default {
  name: "plan",
  data() {
    return {
      loading:true,
      loading2:true,
      exportLoading:false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      totalCount1: undefined,
      // 总条数
      totalCount2: undefined,
      // 参数表格数据
      adminList: [],
      adminList2:[],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        current: 1,
        size: 15,
        name: undefined,
        pageNo:1,
        pageSize:15,
      },
      // 查询参数
      queryParams2: {
        current: 1,
        size: 15,
        pageNo:1,
        pageSize:15,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          { required: true, message: "任务名称不能为空",  trigger: "blur"  }
        ],
        teamId: [
          { required: true, message: "班组名称不能为空",  trigger: ["blur",'change'] }
        ],
        companyCode: [
          { required: true, message: "单位名称不能为空",  trigger: ["blur",'change']}
        ],
        cycle: [
          { required: true, message: "周期不能为空",  trigger: ["blur",'change']}
        ],
        startTime: [
          { required: true, message: "计划开始时间不能为空",  trigger: ["blur",'change']}
        ],
        endTime: [
          { required: true, message: "计划结束时间不能为空",  trigger: ["blur",'change']}
        ],
        startInspectTime: [
          { required: true, message: "执行开始时间称不能为空",  trigger: ["blur",'change']}
        ],
        endInspectTime: [
          { required: true, message: "执行结束时间称不能为空",  trigger: ["blur",'change']}
        ],
      },
      zrr:[],
      cycleList:[
        {dictValue:1,dictLabel:"日"},
        {dictValue:2,dictLabel:"周"},
        {dictValue:3,dictLabel:"月"},
      ],
      implementTimeStart:[],//执行开始时段
      implementTimeEnd:[],//执行结束时段

      dateRange:[],
      teamList:[],
      selectioned:'',//单选中的值
    };
  },
  created() {
    this.getList();//初始化table
    this.zxtimeStart()
    this.zxtimeEnd()
  },
  methods: {
    //分页查询
    handleCurrentChange1(val) {
      this.queryParams.pageNo = val;
      this.getList();
    },
    //分页查询
    handleSizeChange1(val) {
      this.queryParams.pageSize = val;
      this.getList();
    },
    //分页查询
    handleCurrentChange2(val) {
      this.queryParams2.pageNo = val;
      this.getList();
    },
    //分页查询
    handleSizeChange2(val) {
      this.queryParams2.pageSize = val;
      this.getList();
    },

    //强制el-input刷新
    onInput(){
        this.$forceUpdate();
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.loading = false
      setTimeout(()=>{
        this.reset();
      },500)

    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams = {
        name:undefined,
        current:1,
        size:15,
        pageSize:15,
        pageNo:1,
      }
      // this.resetForm("queryForm");
      this.handleQuery();
    },
    // 表单重置
    reset() {
      this.form={}
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.current = 1;
      this.getList();
    },
    /** 执行开始时间 */
    zxtimeStart(){
      let arr = []
      for(let i = 0; i<48;i++){
        arr[i] = {}
        if(i%2 == "NaN"){
          arr[i].value="00:00:00"
        }
        if(i%2 == "0"){
          if(i/2>=10){
            arr[i].value= i/2 + ":00:00"
          }else{
            arr[i].value="0" + i/2 + ":00:00"
          }
        }
        if(i%2 == "1"){
          if(i/2>=10){
            arr[i].value=(i-1)/2 + ":30:00"
          }else{
            arr[i].value="0" + (i-1)/2 + ":30:00"
          }
        }
      }
      this.implementTimeStart = arr
    },
    /** 执行开结束时间 */
    zxtimeEnd(){
      let arr = []
      for(let i = 0; i<49;i++){
        arr[i] = {}
        if(i%2 == "NaN"){
          arr[i].value="00:00:00"
        }
        if(i%2 == "0"){
          if(i/2>=10){
            arr[i].value= i/2 + ":00:00"
          }else{
            arr[i].value="0" + i/2 + ":00:00"
          }
        }
        if(i%2 == "1"){
          if(i/2>=10){
            arr[i].value=(i-1)/2 + ":30:00"
          }else{
            arr[i].value="0" + (i-1)/2 + ":30:00"
          }
        }
      }
      this.implementTimeEnd = arr.slice(1,arr.length)
    },
    /** 查询参数列表 */
    getList() {
      this.loading = true;
      getMaintianPlan(this.queryParams).then(response => {
        this.adminList = response.data.pageList;
        this.totalCount1 = response.data.totalCount;
        this.loading = false;
      });
      getDevopsTeam(this.queryParams).then(response => {
        if(response.data.pageList.length>0){
          this.teamList = response.data.pageList;
        }
      })
    },
    getList2(row){
        this.adminList2 = []
        getPlanPath(this.queryParams2).then(response => {
            this.adminList2 = response.data.pageList;
            this.totalCount2 = response.data.totalCount;
            if(row){
                let list = []
                for(let i = 0; i<this.adminList2.length;i++){
                    if(row.planPathId == this.adminList2[i].id){
                        list.push(this.adminList2[i])
                    }
                }
                setTimeout(() => {
                    var that = this;
                    that.$nextTick(() => {
                        if(list){
                            list.forEach((row) => {
                                that.$refs.dataTable.toggleRowSelection(row, true)
                            })
                        }
                    })
                    this.loading2 = false;
                })
            }else{
                this.loading2 = false;
            }
        });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.title = "修改";
      this.form = JSON.parse(JSON.stringify(row))
      this.getList2(row)
      this.open = true;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.getList2()
      this.title = "新增";
      this.list = []
      this.open = true;
    },
    /** 提交按钮 */
    submitForm(row) {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.endTime = timestampToTime(this.form.endTime)
          this.form.startTime = timestampToTime(this.form.startTime)
          let start = YearMonthDate().split(" ")[0] + " " + this.form.startInspectTime
          let end = YearMonthDate().split(" ")[0] + " " + this.form.endInspectTime
          if(getTimeFormat(this.form.endTime) < getTimeFormat(this.form.startTime)){
            this.$message.error("计划结束时间不能小于计划开始时间");
            return
          }
          if(getTimeFormat(end) <= getTimeFormat(start)){
            this.$message.error("执行结束时间不能小于或等于执行开始时间");
            return
          }
          this.loading = true
          if (this.form.id != undefined) {
            if(this.form.planPathId){
              updateMaintianPlan(this.form).then(response => {
                this.loading = false,
                this.$message.success("修改成功");
                this.open = false;
                this.getList();
              }).catch(()=>{
                this.loading = false
              })
            }else{
              this.$message.error("巡更路线不能为空");
            }
          } else {
            if(this.form.planPathId){
              addMaintianPlan(this.form).then(response => {
                this.loading = false
                if(response.status == "SUCCESS"){
                  this.loading = false,
                  this.$message.success("新增成功");
                  this.open = false;
                  this.getList();
                }
              })
            }else{
              this.$message.error("巡更路线不能为空");
            }
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delMaintianPlan(ids);
        }).then(() => {
          this.getList();
          this.$message.success("删除成功");
        }).catch(() => {});
    },
    /** table */
    dialogCheck(selection, row){
      this.$refs.dataTable.clearSelection()
      if (selection.length === 0) { // 判断selection是否有值存在
          this.form.planPathId = undefined
          this.form.planPathName = undefined
          return
      }else{
          this.selectioned = row
          this.$refs.dataTable.toggleRowSelection(row, true)
          this.form.planPathId = selection[selection.length-1].id
          this.form.planPathName = selection[selection.length-1].name
      }
    },
    /** 导出按钮操作 */
    handleExport() {
      exportMaintianPlan(this.queryParams).then(response =>{
        this.exportLoading = false;
        document.getElementById("xz").href = BASEPATH() + response.data
        document.getElementById("xz").download = response.data
        document.getElementById("xz").click()
      })
    }
  }
};
</script>
<style lang="scss" scoped>
.el-input__prefix{
  top:0px !important
}
//去掉表头多选框
::v-deep .el-table__header-wrapper .el-checkbox {
  display: none;
}
</style>
